
;       

;   flo
;0  -   
;1  -    1 ""
;2  -    2 ""
;3  -    3 "/"
;4  -  
;5  -    4 / 
;6  -   
;7  -     4

.INCLUDE	"m8535def.inc"
.DEF	tm1=r2
.DEF	EEBT=r4
.DEF	EEAH=r5
.DEF	store=r6

.DEF	sek1=r8
.DEF	KKNR2=r9
.DEF	KKNR3=r10
.DEF	KKNR4=r11
.DEF	t20=r12
.DEF	t21=r13
.DEF	KLAV=r14
.DEF	tecc1=r15	;   . .
.DEF	t2=r16 		;   1
.DEF	regim=r17		;   2
.DEF	nomer=r18 	;,    . 
.DEF	flo=r19	; 
.DEF	beg1=r20	;  
.DEF	tec=r21	;    3
.DEF	catod=r22
.DEF	cod=r23
.DEF	SSREG=r24	;  SREG
.DEF	tec1=r25	;   4

.equ	RAM=$060
.equ	adres=$100

.eseg
.org   0x08

.CSEG
.ORG	0
		rjmp Reset
		nop
		nop
		nop
		nop
		nop	
		nop
		nop
		nop
		rjmp TIM0_OVF 
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		 
Reset:	ldi	r30,HIGH(RAMEND)
		out	SPH,r30
		ldi	r30,LOW(RAMEND)
		out	SPL,r30

		ldi tec1,0
		mov sek1,tec1

		ldi tec,0

;		ldi	t2,10
		ldi	beg1,0b11111110
		ldi	regim,0
		ldi	nomer,0
		sec

		clr	flo
		SBR flo,0b11000001
		CBR flo,0b00010000
		;ldi flag,1
		ldi catod,1
		
		ldi	r30,0b11111111		;      B  D
		out	DDRB,r30
		ldi	r30,$FF		
		out	PORTB,r30
		out PORTD,r30
		ldi	r30,0b01111111	
		out DDRD,r30
		ldi	r30,$FF			;     
		out	DDRC,r30
		out	PORTC,r30
		ldi r30,0b11111111	;     A	;	
		out PORTA,r30
		ldi	r30,0b111111111
		out DDRA,r30

		
	;	ldi r30,1<<TOV0		; / 0
	;	out TIFR,r30
		clr r30
		out	TCCR0,r30
		ldi r30,1<<TOIE0		
		out	TIMSK,r30
	;	ldi r30,1<<TOV0		
	;	out TIFR,r30
		ldi r30,$ff-20
		out TCNT0,r30

		ldi	r30,$03			
		out	TCCR0,r30
		;sei
		
		ldi	YL,low(RAM)	;   
		ldi	YH,high(RAM)		
		ldi cod,0
		st	Y,cod

		ldi  tec1,14
		mov tm1,tec1
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)
K0:		ldi tec, 0b11111111
		st	Y+,tec
		dec  tm1
		brne K0

		sei

; 
	

SE1:	nop	
		rjmp SE1


TIM0_OVF: 
		in	SSREG,SREG 	; 
		
SG0:	dec  sek1			;   
		brne selo3
		ldi tec1,255
		mov sek1,tec1
	
		sbrc flo,6			;   
		rjmp S0

		sbrc flo,0
		rjmp MLA1
		SBR  flo,0b00000001
		sbi PORTB,7
		rjmp S0
MLA1:	CBR  flo,0b00000001
		cbi PORTB,7
			
S0:		sbrc flo,6
selo3:	rjmp SEL2

		
		cpi  nomer,0 ;()  . . 1 ( )
		brne SVET2
	
		sbrs flo,0;
		rjmp F1

		ldi  tec1,14
		mov  tm1,tec1

		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)
K10:	ldi tec, 0b01010101
		st	Y+,tec
		dec  tm1
		brne K10
		SBR  flo,0b00010000
		rjmp SEL2

F1:		ldi  tec1,14
		mov tm1,tec1
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)
K11:	ldi 	tec, 0b10101010
		st	Y+,tec
		dec  tm1
		brne K11
		CBR  flo,0b00010000
		rjmp SEL2

SVET2:	cpi  nomer,1 ; () . . 2 (,  .    .)
		brne SVET3

		sbrs flo,0;
		rjmp slon2
		ldi  tec1,14
		mov tm1,tec1
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)
K20:	ldi tec, 0b11111111
		st	Y+,tec
		dec  tm1
		brne K20
		rjmp SEL2

slon2:	ldi  tec1,14
		mov tm1,tec1
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)
K21:	ldi tec, 0b00000000
		st	Y+,tec
		dec  tm1
		brne K21
		rjmp SEL2

SVET3:	cpi  nomer,2 ;()  . . 3 ( .   )
		brne svet4
			
		inc regim

mkk1:	cpi regim,1
		brne sol1 
		ldi	 beg1, 0b11111110
		rjmp VVV3
sol1:	cpi regim,2
		brne sol2 
		ldi	 beg1, 0b11111101
		rjmp VVV3
sol2:	cpi regim,3
		brne sol3 
		ldi	 beg1, 0b11111011		
		rjmp VVV3
sol3:	cpi regim,4
		brne sol4 
		ldi	 beg1, 0b11110111
		rjmp VVV3
sol4:	cpi  regim,5
		brne sol5 
		ldi	 beg1, 0b11101111
		rjmp VVV3
sol5:	cpi  regim,6
		brne sol6 
		ldi	 beg1, 0b11011111
		rjmp VVV3
sol6:	cpi  regim,7
		brne sol7 
		ldi	 beg1, 0b10111111
		rjmp VVV3
sol7:	cpi  regim,8
		brne sol8 
		ldi	 beg1, 0b01111111
		rjmp VVV3
sol8:	cpi  regim,9
		brne out1
		ldi	 beg1, 0b11111111
		ldi	 regim,0			
    				
VVV3:	ldi tec1,14
		mov tm1,tec1
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)
K30:	st	Y+,beg1
		dec  tm1
		brne K30
out1:	rjmp SEL2

SVET4:	cpi  nomer,3 ;() . . 4 (2  .   )
		brne SVET5
	
		inc regim

		cpi  regim,1
		brne solk1 
		ldi	 beg1, 0b11111110
		rjmp VVV4
solk1:	cpi  regim,2
		brne solk2 
		ldi	 beg1, 0b11111100
		rjmp VVV4
solk2:	cpi  regim,3
		brne solk3 
		ldi	 beg1, 0b11111001
		rjmp VVV4
solk3:	cpi  regim,4
		brne solk4 
		ldi	 beg1, 0b11110011
		rjmp VVV4
solk4:	cpi  regim,5
		brne solk5 
		ldi	 beg1, 0b11100111
		rjmp VVV4
solk5:	cpi  regim,6
		brne solk6 
		ldi	 beg1, 0b11001111
		rjmp VVV4
solk6:	cpi  regim,7
		brne solk7 
		ldi	 beg1, 0b10011111
		rjmp VVV4
solk7:	cpi  regim,8
		brne solk8 
		ldi	 beg1, 0b00111111
		rjmp VVV4
solk8:	cpi  regim,9
		brne solk9
		ldi	 beg1, 0b01111111
		rjmp VVV4
solk9:	cpi  regim,10
		brne out1
		ldi	 beg1, 0b11111111
		ldi	 regim,0			
    				
VVV4:	ldi tec1,14
		mov tm1,tec1
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)
K40:	st	Y+,beg1
		dec  tm1
		brne K40
		rjmp SEL2

SVET5:	cpi  nomer,4 ;()  . . 5 (3  .   )
		brne SVET6

		inc regim

		cpi  regim,1
		brne solm1 
		ldi	 beg1, 0b11111110
		rjmp VVV5
solm1:	cpi  regim,2
		brne solm2 
		ldi	 beg1, 0b11111100
		rjmp VVV5
solm2:	cpi  regim,3
		brne solm3 
		ldi	 beg1, 0b11111000
		rjmp VVV5
solm3:	cpi  regim,4
		brne solm4 
		ldi	 beg1, 0b11110001
		rjmp VVV5
solm4:	cpi  regim,5
		brne solm5 
		ldi	 beg1, 0b11100011
		rjmp VVV5
solm5:	cpi  regim,6
		brne solm6 
		ldi	 beg1, 0b11000111
		rjmp VVV5
solm6:	cpi  regim,7
		brne solm7 
		ldi	 beg1, 0b10001111
		rjmp VVV5
solm7:	cpi  regim,8
		brne solm8 
		ldi	 beg1, 0b00011111
		rjmp VVV5
solm8:	cpi  regim,9
		brne solm9
		ldi	 beg1, 0b00111111
		rjmp VVV5
solm9:	cpi  regim,10
		brne solm10
		ldi	 beg1, 0b01111111
		rjmp VVV5			
    				
solm10:	cpi  regim,11
		brne out2
		ldi	 beg1, 0b11111111
		ldi	 regim,0		

VVV5:	ldi tec1,14
		mov tm1,tec1
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)
K50:	st	Y+,beg1
		dec  tm1
		brne K50
out2:	rjmp SEL2


SVET6:	cpi  nomer,5 ; . . 6 ( ,   ;)
		brne SVET7 ;SVET7

	
	
		sbrs flo,0;
		rjmp slon6
		ldi  tec1,7
		mov tm1,tec1
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)
K60:	ldi tec, 0b00000000
		st	Y+,tec
		ldi tec, 0b11111111
		st	Y+,tec
		dec  tm1
		brne K60
		rjmp SEL2

slon6:	ldi  tec1,7
		mov tm1,tec1
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)
K61:	ldi tec, 0b11111111
		st	Y+,tec
		ldi tec, 0b00000000
		st	Y+,tec
		dec  tm1
		brne K61
		rjmp SEL2

SVET7:	cpi  nomer,6 ;()  . . 7 (    ; 4- , 14 - , 58 - ,  )
		brne SVET8
		sbrs flo,0;
		rjmp slon7
		ldi  tec1,14
		mov tm1,tec1
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)
K70:	ldi tec, 0b00001111
		st	Y+,tec
		dec  tm1
		brne K70
		rjmp SEL2

slon7:	ldi  tec1,14
		mov tm1,tec1
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)
K71:	ldi tec, 0b11110000
		st	Y+,tec
		dec  tm1
		brne K71
		rjmp SEL2


SVET8:	cpi  nomer,7 ; . . 8 (     )
		brne SVE9
	
		inc regim

SL80:	cpi regim,1
		brne SL81
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)
		ldi beg1, 0b11111110
		rjmp K81

SVE9:   rjmp SVET9
SL81:	cpi regim,9
		brne SL82
		;adiw YL,1

		ldi	YL,low(RAM+2)
		ldi	YH,high(RAM+2)

		ldi beg1, 0b11111110
		rjmp K81

SL82:	cpi regim,17
		brne SL83
	;	adiw YL,2

		ldi	YL,low(RAM+3)
		ldi	YH,high(RAM+3)

		ldi beg1, 0b11111110
		rjmp K81

SL83:	cpi regim,25
		brne SL84
		;adiw YL,3
		ldi	YL,low(RAM+4)
		ldi	YH,high(RAM+4)
		ldi beg1, 0b11111110
		rjmp K81

SL84:	cpi regim,33
		brne SL85
		;adiw YL,4
		ldi	YL,low(RAM+5)
		ldi	YH,high(RAM+5)
		ldi beg1, 0b11111110
		rjmp K81

SL85:	cpi regim,41
		brne SL86
		;adiw YL,5
		ldi	YL,low(RAM+6)
		ldi	YH,high(RAM+6)

		ldi beg1, 0b11111110
		rjmp K81

SL86:	cpi regim,49
		brne SL87
		;adiw YL,6
		ldi	YL,low(RAM+7)
		ldi	YH,high(RAM+7)
		ldi beg1, 0b11111110
		rjmp K81

SL87:	cpi regim,57
		brne SL88
		ldi	YL,low(RAM+8)
		ldi	YH,high(RAM+8)
		ldi beg1, 0b11111110
		rjmp K81

SL88:	cpi regim,63
		brne SL89
		ldi	YL,low(RAM+9)
		ldi	YH,high(RAM+9)
		ldi beg1, 0b11111110
		rjmp K81

SL89:	cpi regim,71
		brne SL810
		ldi	YL,low(RAM+10)
		ldi	YH,high(RAM+10)
		ldi beg1, 0b11111110
		rjmp K81

SL810:	cpi regim,79
		brne SL811
		ldi	YL,low(RAM+11)
		ldi	YH,high(RAM+11)
		ldi beg1, 0b11111110	
		rjmp K81

SL811:	cpi regim,87
		brne SL812
		ldi	YL,low(RAM+12)
		ldi	YH,high(RAM+12)
		ldi beg1, 0b11111110
		rjmp K81

SL812:	cpi regim,96
		brne SL813
		ldi	YL,low(RAM+13)
		ldi	YH,high(RAM+13)
		ldi beg1, 0b11111110
		rjmp K81

SL813:	cpi regim,104
		brne K81
		ldi	YL,low(RAM+14)
		ldi	YH,high(RAM+14)
		;ldi beg1, 0b11111110
		
		ldi  tec1,13
		mov tm1,tec1
		ldi	YL,low(RAM+14)
		ldi	YH,high(RAM+14)
K800:	ldi beg1, 0b11111111
		st	-Y,beg1
		dec  tm1
		brne K800
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)
		ldi beg1, 0b11111110
		ldi regim,0
		rjmp sel2
		
K81:	lsl beg1
		st	Y,beg1
		rjmp sel2
	
		
SVET9:	cpi  nomer,8 ;() . . 9 ( .     )
		brne SVET10

		sbrs flo,0;
		rjmp SEL2
		inc regim

		sbrs flo,4
		rjmp REVS

;		cpi regim,7
;		brne VVV9
;		ldi	beg1,0b00000001
;;		ldi	regim,0
;		sbrc flo,4
;		rjmp MLAS9
;		SBR  flo,0b00010000
;		rjmp MLA9
;MLAS9:	CBR  flo,0b00010000
;MLA9:	;rjmp SEL2

VVV9:	lsl beg1
		brcc fff1
		ldi	beg1,0b10000000

		sbrc flo,4
		rjmp MLAS9
		SBR  flo,0b00010000
		rjmp MLA9
MLAS9:	CBR  flo,0b00010000
MLA9:	rjmp SEL2

fff1:	ldi tec1,14
		mov tm1,tec1
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)
K90:	st	Y+,beg1
		dec  tm1
		brne K90
		rjmp SEL2

REVS:	lsr beg1
		brcc fff2
		ldi	beg1, 0b00000001
		ldi	regim,0
		sbrc flo,4
		rjmp RLAS9
		SBR  flo,0b00010000
		rjmp RLA9
RLAS9:	CBR  flo,0b00010000

RLA9:	rjmp SEL2

fff2:	;lsr beg1
		ldi tec1,14
		mov tm1,tec1
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)
R30:	st	Y+,beg1
		dec  tm1
		brne R30
		rjmp SEL2


SVET10:	cpi  nomer,9 ;()  . . 10 ( )
		brne SVET11
		sbrs flo,0;
		rjmp SEL2
		inc regim

		cpi regim,1
		brne VVV10
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)
VVV10:	ldi tec, 0b11111111
		st	Y+,tec
		ldi tec, 0b00000000
		st	Y,tec
		cpi regim,15
		brne SELO2
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)
		ldi regim,0

SVET11:	cpi  nomer,10 ; . . 11 (   ;,   )
		brne SVET12
		sbrs flo,0;
		rjmp SEL2
		inc regim

		cpi regim,1
		brne VVV11
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)

VVV11:	ldi tec,0b00000000
		st	Y+,tec
		cpi regim,15
		brne SELO2
		ldi regim,0
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)
		ldi  tec1,14
		mov tm1,tec1
K711:	ldi tec, 0b11111111
		st	Y+,tec
		dec  tm1
		brne K711
SELO2:	rjmp SEL2
  

SVET12:	cpi  nomer,11 ; () . . 12 (   ;,    ())
		brne SVET13
		sbrs flo,0;
		rjmp SEL2
		inc regim

		sbrc flo,4
		rjmp REVS1

		cpi regim,1
		brne VVV12
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)
VVV12:	ldi tec,0b00000000
		st	Y+,tec
		cpi regim,15
		brne SELO2
		ldi regim,0
		SBR  flo,0b00010000
		rjmp SEL2

REVS1:	ldi tec, 0b11111111
		st	-Y,tec
		cpi regim,15
		brne SELO2
		ldi regim,0
		CBR  flo,0b00010000
		rjmp SEL2

SVET13:	cpi  nomer,12 ;() . . 13 (    ,      
		brne SVET14

		sbrc flo,0
		rjmp REVS2

		ldi tec1,7
		mov tm1,tec1
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)

K130:	ldi tec, 0b11111111
		st	Y+,tec
		dec  tm1
		brne K130

		ldi tec1,8
		mov tm1,tec1
		ldi	YL,low(RAM+7)
		ldi	YH,high(RAM+7)
K131:	ldi tec, 0b00000000
		st	Y+,tec
		dec  tm1
		brne K131
		SBR  flo,0b00010000
		rjmp SEL2

REVS2:	ldi tec1,7
		mov tm1,tec1
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)
K132:	ldi tec,0b00000000
		st	Y+,tec
		dec tm1
		brne K132

		ldi tec1,8
		mov tm1,tec1
		ldi	YL,low(RAM+7)
		ldi	YH,high(RAM+7)
K133:	ldi tec,0b11111111
		st	Y+,tec
		dec  tm1
		brne K133
		CBR  flo,0b00010000

		rjmp SEL2

SVET14:	cpi  nomer,13 ; . . 14 (   ;   )
		brne SVET15
		sbrs flo,0;
		rjmp SEL2
		inc regim

		sbrc flo,4
		rjmp REVS3

		ldi  tec1,14
		mov tm1,tec1
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)
K141:	ldi tec, 0b00000000
		st	Y+,tec
		dec  tm1
		brne K141
		SBR  flo,0b00010000
		rjmp SEL2


REVS3:	ldi tec, 0b11111111
		st	-Y,tec
		cpi regim,15
		brne SELL
		ldi regim,0
		CBR  flo,0b00010000
SELL:	rjmp SEL2

SVET15:	cpi  nomer,14 ; . . 15 (    )
		brne SVE16

		inc regim

SLA80:	cpi regim,1
		brne SLA81
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)
		ldi beg1, 0b00000001
		rjmp KA81
SVE16:	rjmp SVET16


SLA81:	cpi regim,9
		brne SLA82
	
		ldi	YL,low(RAM+2)
		ldi	YH,high(RAM+2)

		ldi beg1, 0b00000001
		rjmp KA81

SLA82:	cpi regim,17
		brne SLA83


		ldi	YL,low(RAM+3)
		ldi	YH,high(RAM+3)

		ldi beg1, 0b00000001
		rjmp KA81

SLA83:	cpi regim,25
		brne SLA84
		
		ldi	YL,low(RAM+4)
		ldi	YH,high(RAM+4)
		ldi beg1, 0b00000001
		rjmp KA81

SLA84:	cpi regim,33
		brne SLA85
		
		ldi	YL,low(RAM+5)
		ldi	YH,high(RAM+5)
		ldi beg1, 0b00000001
		rjmp KA81

SLA85:	cpi regim,41
		brne SLA86
		
		ldi	YL,low(RAM+6)
		ldi	YH,high(RAM+6)

		ldi beg1, 0b00000001
		rjmp KA81

SLA86:	cpi regim,49
		brne SLA87
		
		ldi	YL,low(RAM+7)
		ldi	YH,high(RAM+7)
		ldi beg1, 0b00000001
		rjmp KA81

SLA87:	cpi regim,57
		brne SLA88
		ldi	YL,low(RAM+8)
		ldi	YH,high(RAM+8)
		ldi beg1, 0b00000001
		rjmp KA81

SLA88:	cpi regim,65
		brne SLA89
		ldi	YL,low(RAM+9)
		ldi	YH,high(RAM+9)
		ldi beg1, 0b00000001
		rjmp KA81

SLA89:	cpi regim,73
		brne SLA810
		ldi	YL,low(RAM+10)
		ldi	YH,high(RAM+10)
		ldi beg1, 0b00000001
		rjmp KA81

SLA810:	cpi regim,81
		brne SLA811
		ldi	YL,low(RAM+11)
		ldi	YH,high(RAM+11)
		ldi beg1, 0b00000001	
		rjmp KA81

SLA811:	cpi regim,89
		brne SLA812
		ldi	YL,low(RAM+12)
		ldi	YH,high(RAM+12)
		ldi beg1, 0b00000001
		rjmp KA81

SLA812:	cpi regim,97
		brne SLA813
		ldi	YL,low(RAM+13)
		ldi	YH,high(RAM+13)
		ldi beg1, 0b00000001
		rjmp KA81

SLA813:	cpi regim,105
		brne KA81
		ldi	YL,low(RAM+14)
		ldi	YH,high(RAM+14)
		
		
		ldi  tec1,13
		mov tm1,tec1
		ldi	YL,low(RAM+14)
		ldi	YH,high(RAM+14)
KA800:	ldi beg1, 0b11111111
		st	-Y,beg1
		dec  tm1
		brne KA800
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)
		ldi beg1, 0b00000001
		ldi regim,0
		rjmp sel2
		
KA81:	lsl beg1
		ldi tec1, 0xFF
		eor tec1,beg1
		st	Y,tec1
		rjmp sel2

SVET16: cpi  nomer,15 ; . . 16 (      )
		brne SVE17

		sbrs flo,4;
		rjmp DEV1
		dec regim
		rjmp SLV80

DEV1:	inc regim


SLV80:	cpi regim,1
		brne SLV81
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)

		CBR  flo,0b00010000


KVV1:	sbrs flo,4;
		rjmp SD1		
		ldi beg1, 0b10000000
		rjmp BN1
SD1:	ldi beg1, 0b00000001
BN1:	rjmp KV81


SVE17:	rjmp SVET17


SLV81:	cpi regim,9
		brne SLV82
	
		ldi	YL,low(RAM+2)
		ldi	YH,high(RAM+2)

		sbrs flo,4;
		rjmp SD2		
		ldi beg1, 0b10000000
		rjmp BN2
SD2:	ldi beg1, 0b00000001
BN2:	rjmp KV81


SLV82:	cpi regim,17
		brne SLV83

		ldi	YL,low(RAM+3)
		ldi	YH,high(RAM+3)

		sbrs flo,4;
		rjmp SD3		
		ldi beg1, 0b10000000
		rjmp BN3
SD3:	ldi beg1, 0b00000001
BN3:	rjmp KV81

SLV83:	cpi regim,25
		brne SLV84
		
		ldi	YL,low(RAM+4)
		ldi	YH,high(RAM+4)

		sbrs flo,4;
		rjmp SD4		
		ldi beg1, 0b10000000
		rjmp BN4
SD4:	ldi beg1, 0b00000001
BN4:	rjmp KV81

SLV84:	cpi regim,33
		brne SLV85
		
		ldi	YL,low(RAM+5)
		ldi	YH,high(RAM+5)

		sbrs flo,4;
		rjmp SD5		
		ldi beg1, 0b10000000
		rjmp BN5
SD5:	ldi beg1, 0b00000001
BN5:	rjmp KV81

SLV85:	cpi regim,41
		brne SLV86
		
		ldi	YL,low(RAM+6)
		ldi	YH,high(RAM+6)

		sbrs flo,4;
		rjmp SD6		
		ldi beg1, 0b10000000
		rjmp BN6
SD6:	ldi beg1, 0b00000001
BN6:	rjmp KV81

SLV86:	cpi regim,49
		brne SLV87
		
		ldi	YL,low(RAM+7)
		ldi	YH,high(RAM+7)

		sbrs flo,4;
		rjmp SD7		
		ldi beg1, 0b10000000
		rjmp BN7
SD7:	ldi beg1, 0b00000001
BN7:	rjmp KV81

SLV87:	cpi regim,57
		brne SLV88
		ldi	YL,low(RAM+8)
		ldi	YH,high(RAM+8)

		sbrs flo,4;
		rjmp SD8		
		ldi beg1, 0b10000000
		rjmp BN8
SD8:	ldi beg1, 0b00000001
BN8:	rjmp KV81

SLV88:	cpi regim,65
		brne SLV89
		ldi	YL,low(RAM+9)
		ldi	YH,high(RAM+9)

		sbrs flo,4;
		rjmp SD9		
		ldi beg1, 0b10000000
		rjmp BN9
SD9:	ldi beg1, 0b00000001
BN9:	rjmp KV81

SLV89:	cpi regim,73
		brne SLV810
		ldi	YL,low(RAM+10)
		ldi	YH,high(RAM+10)

		sbrs flo,4;
		rjmp SD10		
		ldi beg1, 0b10000000
		rjmp BN10
SD10:	ldi beg1, 0b00000001
BN10:	rjmp KV81

SLV810:	cpi regim,81
		brne SLV811
		ldi	YL,low(RAM+11)
		ldi	YH,high(RAM+11)

		sbrs flo,4;
		rjmp SD11		
		ldi beg1, 0b10000000
		rjmp BN11
SD11:	ldi beg1, 0b00000001
BN11:	rjmp KV81

SLV811:	cpi regim,89
		brne SLV812
		ldi	YL,low(RAM+12)
		ldi	YH,high(RAM+12)
		
	    sbrs flo,4;
		rjmp SD12		
		ldi beg1, 0b10000000
		rjmp BN12
SD12:	ldi beg1, 0b00000001
BN12:	rjmp KV81

SLV812:	cpi regim,97
		brne SLV813
		ldi	YL,low(RAM+13)
		ldi	YH,high(RAM+13)

		sbrs flo,4;
		rjmp SD13		
		ldi beg1, 0b10000000
		rjmp BN13
SD13:	ldi beg1, 0b00000001
BN13:	rjmp KV81

SLV813:	cpi regim,105
		brne KV81
		;rjmp KV81

		SBR  flo,0b00010000
	
		
KV81:	sbrs flo,4;
		rjmp SD14		
		lsr beg1

  		rjmp BN14


SD14:	lsl beg1


BN14:	ldi tec1, 0xFF
		eor tec1,beg1
		st	Y,tec1
		rjmp sel2



SVET17: NOP


	

SEL2:
		ldi  tec1,0b11111110;  1 ; 
		out  PORTC,tec1
		nop
		nop
		nop
		sbic PIND,7
		rjmp S1
		sbrc flo,1
		rjmp ms1

		SBR  flo,0b00000010
		inc nomer
		cpi  nomer,16
		brne SNN1
		ldi	nomer,0
SNN1:	ldi	YL,low(RAM)	; 
		ldi	YH,high(RAM)			;
		st	Y,nomer
		rjmp S11
S1:		CBR  flo,0b00000010

S11:	ldi  tec1,0b11111101;  2 ; 
		out  PORTC,tec1
		nop
		nop
		nop
		sbic PIND,7
		rjmp S2
		sbrc flo,2
		rjmp ms1
		SBR  flo,0b00000100
		cpi  nomer,0
		breq SNV1
		dec nomer
SNV1:	ldi	YL,low(RAM)	; 
		ldi	YH,high(RAM)			;
		st	Y,nomer
		rjmp S11

S2:		CBR  flo,0b00000100
		
		ldi  tec1,0b11111011;  3 ; C/
		out  PORTC,tec1
		nop
		nop
		nop
		sbic PIND,7
		rjmp S3
		sbrc flo,3
		rjmp ms1
		SBR  flo,0b00001000


		CBR flo,0b00010000
		ldi	regim,0
		ldi  tec1,14
		mov tm1,tec1
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)
KS2:	ldi tec, 0b11111111
		st	Y+,tec
		dec  tm1
		brne KS2

		sbrc flo,6
		rjmp MLAS1
		SBR  flo,0b01000000
		rjmp MLA2
MLAS1:	CBR  flo,0b01000000
MLA2:	rjmp  ms1

S3: 	CBR  flo,0b00001000
	


		ldi  tec1,0b11110111;  4 ; /  
		out  PORTC,tec1
		nop
		nop
		nop
		sbic PIND,7
		rjmp S4
		sbrc flo,5
		rjmp ms1
		SBR  flo,0b00100000

		sbrc flo,7
		rjmp MLAX1
		SBR  flo,0b10000000
		ldi  tec1,14
		mov tm1,tec1
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)
KX2:	ldi tec, 0b11111111
		st	Y+,tec
		dec  tm1
		brne KX2
		rjmp MLX2


MLAX1:	CBR  flo,0b10000000

		ldi  tec1,14
		mov tm1,tec1
		ldi	YL,low(RAM+1)
		ldi	YH,high(RAM+1)
KX3:	ldi tec, 0b00000000
		st	Y+,tec
		dec  tm1
		brne KX3
MLX2:	rjmp  ms1


S4: 	CBR  flo,0b00100000
	
ms1:	sbi PORTD,0 ;  
		sbi PORTD,1
		sbi PORTD,2
		sbi PORTD,3
		sbi PORTD,4
		sbi PORTD,5
		sbi PORTD,6
		sbi PORTB,0
		sbi PORTB,1
		sbi PORTB,2
		sbi PORTB,3
		sbi PORTB,4
		sbi PORTB,5
		sbi PORTB,6
		lsl catod
		sbrs catod,7
		brne m0
		ldi	catod,1
	
		
m0:		ldi	XL,low(RAM)	;   1   2
		ldi	XH,high(RAM)
		ldi	ZL,low(RAM+8)
		ldi	ZH,high(RAM+8)

ma1:	sbrs catod,0
		rjmp  ma2
		adiw XL,0
		ld cod,X       ;   
		CPI  cod,0
		brne m10
		ldi  tec1,0b11000000
m10:	CPI  cod,1
		brne m11
		ldi  tec1,0b11111001
m11:	CPI  cod,2
		brne m12
		ldi  tec1,0b10100100
m12:	CPI  cod,3
		brne m13
		ldi  tec1,0b10110000
m13:	CPI  cod,4
		brne m14
		ldi  tec1,0b10011001
m14:	CPI  cod,5
		brne m15
		ldi  tec1,0b10010010
m15:	CPI  cod,6
		brne m16
		ldi  tec1,0b10000010
m16:	CPI  cod,7
		brne m17
		ldi  tec1,0b11111000
m17:	CPI  cod,8
		brne m18
		ldi  tec1,0b10000000
m18:	CPI  cod,9
		brne m19
		ldi  tec1,0b10010000
							
m19:	CPI  cod,10
		brne m20
		ldi  tec1,0b10001000

m20:	CPI  cod,11
		brne m21
		ldi  tec1,0b00000000

m21:	CPI  cod,12
		brne m22
		ldi  tec1,0b11000110

m22:	CPI  cod,13
		brne m23
		ldi  tec1,0b01000000

m23:	CPI  cod,14
		brne m24
		ldi  tec1,0b10000110

m24:	CPI  cod,15
		brne m25
		ldi  tec1,0b10001110

m25:	out  PORTC,tec1

		adiw ZL,0
		cbi PORTD,0
		cbi PORTB,0
		rjmp  mVX1
				
ma2:	sbrs catod,1
		rjmp  ma3
		adiw XL,1
		adiw ZL,1
		cbi PORTD,1
		cbi PORTB,1
		rjmp  mVX
				
ma3:	sbrs catod,2
		rjmp  ma4
		adiw XL,2
		adiw ZL,2
		cbi PORTD,2
		cbi PORTB,2
		rjmp  mVX

ma4:	sbrs catod,3
		rjmp  ma5
		adiw XL,3 
		adiw ZL,3
		cbi PORTD,3
		cbi PORTB,3
		rjmp  mVX
					
ma5:	sbrs catod,4
		rjmp  ma6
		adiw XL,4
		adiw ZL,4
		cbi PORTD,4
		cbi PORTB,4
		rjmp  mVX

ma6:	sbrs catod,5
		rjmp  ma7
		adiw XL,5
		adiw ZL,5
		cbi PORTD,5
		cbi PORTB,5
		rjmp  mVX

ma7:	sbrs catod,6
		rjmp  ma8
		adiw XL,6
		adiw ZL,6
		cbi PORTD,6
		cbi PORTB,6
		rjmp  mVX

ma8:	nop
						;
mVX:	ld tec1,X
		out PORTC,tec1
mVX1:	ld tec1,Z
		out PORTA,tec1

	
ma30:	ldi r30,$ff-20
		out TCNT0,r30
		out SREG,SSREG
	
		reti		
.EXIT
